package graph;

import Position.Vertex;
import Position.Edge;

public interface Graph
    extends PositionalContainer, InspectableGraph {

  //Inserisce un vertice isolato nel grafo che contiene element
  public Vertex insertVertex(Object element);

  //Inserisce un arco contenente element tra i vertici v1 e v2
  //Se il grafo  orientato v1  l'origine e v2  la destinazione
  public Edge insertEdge (Vertex v1, Vertex v2, Object element);

  //Cancella il vertice v e tutti gli archi incidenti su esso
  public void removeVertex(Vertex v);

  //Cancella l'arco e
  public void removeEdge(Edge e);

  //Cancella l'arco tra i nodi v1 e v2
  public void removeEdge(Vertex v1, Vertex v2);

  //Sostituisce l'elemento in v con x
 public void replace(Vertex v, Object x);

 //Sostituisce l'elemento in e con x
 public void replace(Edge e, Object x);

}