package graph;

import List.NodeList;
import iteratore.VertexIteratorAdapter;
import iteratore.VertexIterator;
import iteratore.EdgeIterator;
import iteratore.EdgeIteratorAdapter;
import Position.Vertex;
import Position.ILVertex;

public abstract class ILUndirectedGraph
    implements UndirectedGraph {

  NodeList _vertices;
  NodeList _edges;

  public ILUndirectedGraph() {
    _vertices = new NodeList();
    _edges = new NodeList();
  }

  public int size() {
    return _vertices.size() + _edges.size();
  }

  public int numVertices() {
    return _vertices.size();
  }

  public int numEdges() {
    return _edges.size();
  }

public VertexIterator vertices() {
    return new VertexIteratorAdapter(_vertices.elements());
  }

  public EdgeIterator edges() {
    return new EdgeIteratorAdapter(_vertices.elements());
  }

public Vertex aVertex() {
    return (Vertex) _vertices.first();
  }

  public int degree(Vertex v) {
    // ILVertex tmp = checkVertex(v);
    //  approssimato dalla seguente linea di codice
    ILVertex tmp = (ILVertex) v;
    return tmp.inDegree();
  }
}