package Position;

//La classe ILVertex implementa l'interfaccia Vertex per grafi non orientati.
//Questa classe sar alla base della rappresentazione del grafo
//tramite Incidence List (rappresentazione del grafo tramite lista degli
//archi e lista dei vertici)

public class ILVertex
    implements Vertex {

  protected Object _element;
  protected boolean _isNull; //rappresenta il nodo nullo
  protected int inDegree;    // usato nei grafi non direzionati
  protected int outDegree;

  public ILVertex() {
    _isNull = true;
  }

  public ILVertex(Object o) {
    _element = o;
  }

  public Object element() {
    return _element;
  }

  public Object setElement(Object o) {
    Object tmp = _element;
    _element = o;
    return tmp;
  }

  public int inDegree() {
    return inDegree;
  }

  public int setInDegree(int d) {
    inDegree = d;
    return inDegree;
  }

  public int outDegree() {
    return outDegree;
  }

  public int setOutDegree(int d) {
    outDegree = d;
    return outDegree;
  }


  //Serve per rappresentare il nodo nullo. Pu essere restutuito da aVertex
  public boolean isNull() {
    return _isNull;
  }
}