package graph;
import Position.Vertex;
import Position.Edge;
import iteratore.EdgeIterator;
import iteratore.VertexIterator;

public interface InspectableDirectedGraph extends InspectableGraph{

  //Restituisce il vertice origine di e
  public Vertex origin (Edge e);

  //Restituisce il vertice destinazione di e
  public Vertex destination (Edge e);

  //Restituisce il numero di archi entranti in v
  public int inDegree(Vertex v);

  //Restituisce il numero di archi uscenti da v
  public int outDegree(Vertex v);

  //Restituisce un iteratore sugli archi uscenti da v
  public EdgeIterator outIncidentEdges(Vertex v);

  //Restituisce un iteratore sugli archi entranti in v
  public EdgeIterator inIncidentEdges(Vertex v);

  //Restituisce un iteratore sui vertici adiacenti a v tramite archi uscenti
  public VertexIterator outAdjacentVertices(Vertex v);

  //Restituisce un iteratore sui vertici adiacenti a v tramite archi entranti
  public VertexIterator inAdjacentVertices(Vertex v);
}