package graph;

import iteratore.EdgeIterator;
import iteratore.VertexIterator;
import Position.Edge;
import Position.Vertex;

public interface InspectableGraph
    extends InspectablePositionalContainer {

  //restituisce il numero di vertici del grafo
  public int numVertices();

  //restituisce il numero di archi del grafo
  public int numEdges();

  //restituisce un iteratore sui vertici del grafo
  public VertexIterator vertices();

  //restituisce un vertice arbitrario del grafo
  public Vertex aVertex();

  //restituisce un iteratore sugli archi del grafo
  public EdgeIterator edges();

  //restituisce un arco arbitrario del grafo
  public Edge anEdge();

  //restituisce true se v1 e v2 sono adiacenti
  public boolean areAdjacent(Vertex v1, Vertex v2);

  //restituisce il grado del vertice v
  public int degree(Vertex v);

  //restituisce un iteratore sui vertici adiacenti al vertice v
  public VertexIterator adjacentVertices(Vertex v);

  //restituisce un iteratore sugli archi adiacenti al vertice v
  public EdgeIterator incidentEdges(Vertex v);

  //restituisce un array di grandezza due contenente i vertici incidenti su e
  public Vertex[] endVertices(Edge e);

  //restituisce l'estremit di e distinta da v (l'altro vertice incidente su e)
  public Vertex opposite(Vertex v, Edge e);

}
